<template>
  <button type="button" v-if="!link" class="flex button" :class="mode">
    <span v-if="icon" class="button-icon"><img :src="iconSrc" /></span>
    <slot></slot>
  </button>
  <router-link v-else :to="to">
    <img v-if="icon" :src="iconSrc" />
    <slot></slot>
  </router-link>
</template>

<script>
export default {
  props: {
    mode: {
      type: String,
      required: false,
      default: null,
    },
    link: {
      type: Boolean,
      required: false,
      default: false,
    },
    icon: {
      type: String,
      required: false,
      default: null,
    },
    to: {
      type: String,
      required: false,
      default: "/",
    },
  },
  computed: {
    iconSrc() {
      return require("@/assets/" + this.icon);
    },
  },
};
</script>

<style scoped>
.button {
  --gap: 0.5rem;
  border: 0;
  border-radius: 10rem;
  color: hsl(var(--clr-neutral-100));
  cursor: pointer;
  font-weight: var(--fw-500);
  padding: 0.75em 1.5em;
  cursor: pointer;
  justify-content: space-around;
}

.primary {
  color: hsl(var(--clr-btn-primary-text));
  background: hsl(var(--clr-btn-primary-bg));
}
.primary:hover {
  background: hsl(var(--clr-btn-primary-hover));
}
.secondary {
  color: hsl(var(--clr-btn-secondary-text));
  background: hsl(var(--clr-btn-secondary-bg));
}
.secondary:hover {
  background: hsl(var(--clr-btn-secondary-hover));
}
.tertiary {
  color: hsl(var(--clr-btn-tertiary-text));
  background: hsl(var(--clr-btn-tertiary-bg));
}
.tertiary:hover {
  background: hsl(var(--clr-btn-tertiary-hover));
}
.quaternary {
  color: hsl(var(--clr-btn-quaternary-text));
  background: hsl(var(--clr-btn-quaternary-bg));
}
.quaternary:hover {
  background: hsl(var(--clr-btn-quaternary-hover));
}
.danger {
  background: hsl(var(--clr-danger));
}
.danger:hover {
  background: hsl(var(--clr-danger-hover));
}
.button-icon {
  display: inline-flex;
  padding: 0.625rem;
  background: hsl(var(--clr-neutral-100));
  border-radius: 50%;
}

.delete-icon,
.sun-icon {
  background: transparent;
  padding: 0;
}
.btn-new-invoice {
  padding: 0.5em 1em 0.5em 0.5em;
}

a {
  text-decoration: none;
  font: inherit;
  background: transparent;
  color: inherit;
  cursor: pointer;
}
</style>
